/* Copyright Faeem Ali 
 * email: kodgehopper@netscape.net
 *
 *----------------------------------------------------------------------
 * This file is part of quickrun
 *
 *  quickrun is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  quickrun is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with quickrun in the file COPYING; if not, write to the Free Software
 *  Foundation, Inc.:
 *      59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *----------------------------------------------------------------------
 */

#ifndef _RUNBAR_
#define _RUNBAR_

#include <stdio.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <gdk/gdkkeysyms.h>
#include <glib.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

extern char *optarg;
extern int optind, opterr, optopt;

/* main widgets. some are used in more than one function */
GtkWidget *window=NULL;
GtkWidget *combobox=NULL;
GtkWidget *mainhbox=NULL;
GtkWidget *completionhbox=NULL; //hbox to hold list of completions
GtkWidget *cscrollwindow=NULL; //scrolled window for completions
GtkWidget *clist=NULL;
GtkWidget *mainvbox=NULL;
GtkWidget *label=NULL;
GtkAccelGroup *accel_group_window=NULL; //for keybindings for window

/* misc globals */
char *position=NULL; //where window should be placed 
char *homedir_ptr=NULL; //pointer to environment
char *homedir=NULL; //path to home directory
char *path_string_ptr=NULL; //pointer to $PATH variable in environment
char *path_string=NULL; //stores a copy of the PATH variable
char *filename=NULL; //name of history file
GList *list=NULL;
GList *completions=NULL; //list of completions
guint max_num_history=10; //maximum number of elements in the history list
int window_extended=0; /* indicates whether or not the main window
			* has been resized */

int fd; //descriptor for lock file
int single=0; //if 1, then only one instance of the program can run
int keep=0; //if 1, then the window doesnt close after a command is run

/* prototypes */
void process_args(int *argc, char **argv[]);
void initialize();
gboolean text_complete(GtkWidget *widget, GdkEventKey *event, gpointer data);
void show_blank_list();
void show_completions_list();
void popup_row_selected(GtkCList *clist, gint row, gint col, 
			GdkEventButton *event, gpointer data);
int check_single();
GList *get_history_list();
void combobox_enter(GtkWidget *widget, GdkEvent *event, gpointer data);
void delete_window(GtkWidget *window, gpointer data);
void show_help(char *name);
void show_list();
#endif
